#include <netinet/ip_icmp.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>

#define IPHDRSIZE	sizeof(struct iphdr)
#define ICMPHDRSIZE	sizeof(struct icmphdr)
#define PACKETSIZE	(IPHDRSIZE + 64)

u_short in_cksum(u_short *addr, int len);
char *packet_create(struct sockaddr_in *dest, struct sockaddr_in *spoof);

int main(int argc, char *argv[])
{
    int i,s;
    struct hostent *hp;
    char *packet;
    struct sockaddr_in spoofaddr;
    struct sockaddr_in destaddr;

    if (argc!=3)
    {
	printf("Usage: %s celcim spoofcim\n",argv[0]);
	exit(1);
    }
	    
    /*socket letrehozasa*/
    s=socket(AF_INET, SOCK_RAW, IPPROTO_RAW);
    setuid(getuid());//root jogok eldobsa FONTOS

    /*cel ip cime*/
    if ((hp = gethostbyname(argv[1])) == 0) 
    {
	herror("gethostbyname");
	exit(1);
    }
    /*cel sockaddr kitoltese*/
    bzero(&destaddr, sizeof(destaddr));
    bcopy((char *)hp->h_addr, (char *)&destaddr.sin_addr, hp->h_length);
    destaddr.sin_family = AF_INET;
    /*spoof ip cime*/
    if ((hp = gethostbyname(argv[2])) == 0) 
    {
	herror("gethostbyname");
	exit(1);
    }
    /*cel sockaddr kitoltese*/
    bzero(&spoofaddr, sizeof(spoofaddr));
    bcopy((char *)hp->h_addr, (char *)&spoofaddr.sin_addr, hp->h_length);
    spoofaddr.sin_family = AF_INET;

    packet=packet_create(&destaddr,&spoofaddr);

    /*csomag elkuldese haromszor*/
    for(i=0;i<3;i++)
    {
    printf("sending packet %d.\n",i+1);
    if (sendto(s, packet, PACKETSIZE, 0, (struct sockaddr*)&destaddr,
	sizeof(struct sockaddr))<0)
	{
	    printf("nem ment");
	    exit(1);
	 }
	sleep(1);
    }

    close(s);
    free(packet);
}

char *packet_create(struct sockaddr_in *dest, struct sockaddr_in *spoof)
{
    char *packet;
    struct iphdr *iph;
    struct icmphdr *icmph;
    
    packet=(char *)malloc(PACKETSIZE);
    bzero(packet,PACKETSIZE);

    iph=(struct iphdr*)packet;
    icmph=(struct icmphdr*)&packet[IPHDRSIZE];
    
    /*IP fejlec*/
    iph->version  = 4;
    iph->ihl      = 5; 
    iph->ttl      = 254;
    iph->protocol = IPPROTO_ICMP;
    iph->tot_len  = htons(PACKETSIZE);
    bcopy((char *)&dest->sin_addr, &iph->daddr, sizeof(iph->daddr));
    bcopy((char *)&spoof->sin_addr, &iph->saddr, sizeof(iph->saddr)); 
    iph->check=in_cksum((u_short *)iph,IPHDRSIZE);

    /*ICMP fejlec*/
    icmph->type = ICMP_ECHO;
    icmph->un.echo.sequence = 1;
    icmph->un.echo.id = getpid();			/* ID */
    icmph->checksum = in_cksum((u_short *)icmph,PACKETSIZE-IPHDRSIZE);
    
    return packet;
}

/*
 * in_cksum --
 *	Checksum routine for Internet Protocol family headers (C Version)
 */
u_short
in_cksum(addr, len)
	u_short *addr;
	int len;
{
	register int nleft = len;
	register u_short *w = addr;
	register int sum = 0;
	union {
		u_short	us;
		u_char	uc[2];
	} last;
	u_short answer;

	/*
	 * Our algorithm is simple, using a 32 bit accumulator (sum), we add
	 * sequential 16 bit words to it, and at the end, fold back all the
	 * carry bits from the top 16 bits into the lower 16 bits.
	 */
	while (nleft > 1)  {
		sum += *w++;
		nleft -= 2;
	}

	/* mop up an odd byte, if necessary */
	if (nleft == 1) {
		last.uc[0] = *(u_char *)w;
		last.uc[1] = 0;
		sum += last.us;
	}

	/* add back carry outs from top 16 bits to low 16 bits */
	sum = (sum >> 16) + (sum & 0xffff);	/* add hi 16 to low 16 */
	sum += (sum >> 16);			/* add carry */
	answer = ~sum;				/* truncate to 16 bits */
	return(answer);
}
